<template>
	<div class="vairus-card flex" 
		:class="[
			highlighted ? 'selected' : '', 
			vairus.vairus_type.rarity, 
			vairus.vairus_type.biome, 
			glitched ? 'glitch' : '', 
			stats ? 'has-stats' : '', 
			glow ? 'glow' : '', 
			color ? 'lightestazure'+color+'color' : 'lightestazure-color',
			color
		]" 
		v-on:click="clicked(vairus.unique_id, $event)" @contextmenu="rightClicked($event, vairus.unique_id)"
	>
		<div class="columns-12">
			<div class="vairus-header flex space h-top">
				<div class="name hustle">{{vairus.label}}</div>
				<div class="level">
					<div>LV <span class="bold">{{vairus.level}}</span></div>
					<div class="small-font" v-if="options.show_potential" v-tooltip="'potential'">{{vairus.potential}}%</div>
				</div>
			</div>
			<div class="vairus-content">
				<div class="wrapper">
					<vairus-image :vairus="vairus" :glitch="glitched" />
					
					<div class="exhausted" :class="exhausted" v-if="exhausted && !hide_exhaustion">
						<span>{{getLocale('exhausted_'+exhausted)}}</span>
					</div>
				</div>
			</div>

			<div class="vairus-footer flex space v-center" :class="{'has-stats' : stats}">
				<div class="rarity uppercase small-font">{{getLocale(vairus.vairus_type.rarity)}}</div>
			
				<div class="vairus-mutations flex" v-if="show_footer != 'false'" >
					<div class="attribute" v-for="attribute in vairus.attributes" :class="[attribute+'-bkg']" v-tooltip="attribute"></div>
				</div>
			</div>
		</div>
		
		<div class="vairus-stats" :class="[ color ? color+'-bkg' : 'azure-bkg']" v-if="stats">
			<div v-for="(value, stat) in vairus.current_stats" class="stat" :class="[ stat ]" v-tooltip="stat">
				<div class="image" :class="[ color ? 'lightest'+color+'-bkg' : 'lightestazure-bkg']">
					<img class="icon" v-bind:src="getImage(stat+'.svg')">
				</div>
				<div class="text">{{value.total}}</div>
			</div>
		</div>
	</div>
</template>


<script>
	import VairusImage from '../components/VairusImage.vue';
	import { vueEventBus } from '../classes/eventBus.js';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	
	export default {
		props: ['vairus', 'highlighted', 'show_footer', 'hide_exhaustion', 'stats', 'color', 'glow'],
		data: function () {
			return{ exhausted : false }
		},
		computed: {
			glitched(){
				return this.vairus.attributes.indexOf('glitch') !== -1;
			}
		},
		created() {
			if(typeof vueEventBus !== 'undefined'){
				vueEventBus.$on('heartbeat', this.updateExhaustion);
			}
			this.updateExhaustion(Date.now());
			
		},
		beforeDestroy() {
			if(typeof vueEventBus !== 'undefined'){
				vueEventBus.$off('heartbeat', this.updateExhaustion);
			}
		},
		methods: {
			clicked(unique_id, e){
				this.$emit('clicked', unique_id, e);
			},
			rightClicked(e, unique_id){
				e.preventDefault();
				this.$emit('rightclicked', unique_id);
			},
			updateExhaustion(current_time){
				let exhaustion = this.$props.vairus.exhaustion;
				
				if(exhaustion == null){
					this.exhausted = null;
				}else if(typeof exhaustion == 'string'){
					this.exhausted = exhaustion;
				}else{
					this.exhausted = (current_time < this.$props.vairus.exhaustion) ? 'exhausted' : null;
				}
			}
		},
		mixins: [commonMixin, storeGettersMixin],
		components: {
			VairusImage
		}
	}
</script>


<style lang="scss" scoped>
	@import "../styles/variables";

	.vairus-card{
		position: relative;
		margin: 10px;
		width: 225px;
		height: 320px;
		background-color: $black;
		box-shadow: 0px 2px 10px 0px rgba(36, 36, 36, 0.30);
		border-radius: 10px;
		cursor: pointer;
		overflow: hidden;
		
		&.has-stats{
			width: 275px;
		}
		
		&.epic{
			background-size: 200% 200%;
			background-position: 91% 100%;
			color: black;
			
			&.mountain{
				background-image: linear-gradient(130deg, #000, #B67341, #000);
			}
			&.sky{
				background-image: linear-gradient(130deg, #000, #F2F2F2, #000);
			}
			&.desert{
				background-image: linear-gradient(130deg, #000, #FFCE4A, #000);
			}
			&.ocean{
				background-image: linear-gradient(130deg, #000, #38A0D2, #000);
			}
			&.swamp{
				background-image: linear-gradient(130deg, #000, #E5E323, #000);
			}
			&.city{
				background-image: linear-gradient(130deg, #000, #BFD2D2, #000);
			}
			&.glacier{
				background-image: linear-gradient(130deg, #000, #BFD2D2, #000);
			}
			&.forest{
				background-image: linear-gradient(130deg, #000, #7BA41D, #000);
			}
			
			&:hover{
				-webkit-animation: shine 0.5s ease forwards;
				animation: shine 0.5s ease forwards;
			}
		}
		
		&.selected{
			background-color: $darkestred;
			color: $lightestred;
			background-image: none !important;
		}
		
		
		.name{
			font-size: 40px;
			text-transform: lowercase;
			
			&:first-letter {
				text-transform: uppercase;
			}
		}
		.exhausted{
			position: absolute;
			left: 0;
			right: 0;
			top: 0;
			bottom: 0;
			background-color: rgba(0,0,0,0.8);
			border-radius: 50%;
			border: 5px solid $lightestazure;
			color: $lightestazure;
			opacity: 1;
			transition: opacity 0.5s;
			
			&.assigned{
				border-color: $lightpink;
				color: $lightpink;
			}
			&.matrix{
				border-color: $lightorange;
				color: $lightorange;
			}

			span{
				position: absolute;
				left: 50%;
				top: 50%;
				transform: translate(-50%,-50%);
				text-transform: uppercase;
				text-align: center;
				line-height: 1.1;
			}
		}
		
		.level{
			text-align: right;
		}
		
		.vairus-header{
			padding: 10px;
		}
		
		.vairus-content{
			padding: 0 10px;
			padding-top: 0;
			
			.wrapper{
				position: relative;
				padding-top: 100%;
			}
		}
		
		.vairus-footer{
			padding-top: 10px;
			padding-bottom: 20px;
			min-height: 33px;
			
			.rarity{
				padding-left: 10px;
				transform: translateY(2px);
			}
			
			.vairus-mutations{
				padding: 0 10px;
				justify-content: right;
				transform: translateY(-3px);
			}
			.attribute{
				width: 15px;
				height: 15px;
				margin: 8px 10px 0;
				transform: rotate(-45deg);
			}
			.button{
				display: block;
				width: 80%;
				margin: 10px auto 0;
			}
		}
		
		.vairus-stats{
			padding: 0 10px;
			display: flex;
			flex-direction: column;
			justify-content: center;
		
			.stat{
				padding: 8px 0;
				text-align: center;
				
				.text{
					color: black;
				}
				
				.image{
					display: inline-block;
					position: relative;
					width: 30px;
					height: 30px;
					border-radius: 50%;
					margin-top: 5px;

					img{
						position: absolute;
						left: 5px;
						top: 5px;
						right: 5px;
						bottom: 5px;
						width: 20px;
						height: 20px;
					}
				}
			}
		}
		
		/* COLORS */
		
		&.glow{
			box-shadow: 0px 0px 30px 0px white;
			
			&.pink{
				box-shadow: 0px 0px 30px 0px $lightestpink;
			}
			
			&.orange{
				box-shadow: 0px 0px 30px 0px $lightestorange;
			}
		}
		
		&.has-stats .exhausted{
			display: none;
		}
	}
	
	
	@media screen and (max-height: 480px) {
		.vairus-card{
			width: 175px;
			height: 250px;
			
			&.has-stats{
				width: 214px;
			}
			
			.vairus-stats .stat{
				padding: 5px 0;
				
				.image{
					width: 20px;
					height: 20px;
					
					img{
						left: 2px;
						top: 2px;
						right: 2px;
						bottom: 2px;
						width: 16px;
						height: 16px;
					}
				}
			}
		}
	}
	
	
	@-webkit-keyframes shine {
		0%{background-position:91% 100%}
		50%{background-position:10% 0%}
		100%{background-position:91% 100%}
	}
	@keyframes shine { 
		0%{background-position:91% 100%}
		50%{background-position:10% 0%}
		100%{background-position:91% 100%}
	}
	@-webkit-keyframes glow {
		0%{box-shadow: 0px 0px 10px 0px white;}
		50%{box-shadow: 0px 0px 30px 0px white;}
		100%{box-shadow: 0px 0px 10px 0px white;}
	}
</style>




